<template>
    <ion-page>
        <ion-content>
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <div class="card-container">
                <ion-card>
                    <ion-row>
                        <ion-col
                            size-md="3"
                            size="12"
                            class="ion-padding ion-blue-bkg"
                        >
                            <img
                                class="max-h"
                                src="../../../resources/icon.png"
                                alt="logo"
                                loading="lazy"
                            />
                        </ion-col>
                        <ion-col size-md="9" size="12" class="welcome">
                            <ion-card-header>
                                <ion-card-title
                                    >Vítejte v aplikaci WiFi IoT</ion-card-title
                                >
                            </ion-card-header>

                            <ion-card-content>
                                <div>user:heslo123</div>
                                <div>admin:heslo123</div>
                                <br />
                                <ion-input
                                    required
                                    label-placement="floating"
                                    fill="outline"
                                    v-model="credentials.username"
                                    label="Jméno"
                                ></ion-input>
                                <br />
                                <ion-input
                                    required
                                    label-placement="floating"
                                    fill="outline"
                                    v-model="credentials.password"
                                    type="password"
                                    label="Heslo"
                                >
                                    <ion-input-password-toggle
                                        slot="end"
                                    ></ion-input-password-toggle>
                                </ion-input>
                                <br />
                                <ion-button @click="onLogIn" color="primary"
                                    >Přihlásit</ion-button
                                >
                            </ion-card-content>
                        </ion-col>
                    </ion-row>
                </ion-card>
            </div>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import { reactive } from 'vue'
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { Route } from '@/router/route'
import { useUserStore } from '@/stores/userStore'
import {
    IonPage,
    IonProgressBar,
    IonInput,
    IonInputPasswordToggle,
    IonButton,
    IonCard,
    IonRow,
    IonCol,
    IonCardTitle,
    IonCardHeader,
    IonCardContent,
    IonContent,
} from '@ionic/vue'
import toast from '@/helpers/toast'

const user = useUserStore()
const router = useRouter()

const credentials = reactive({
    username: '',
    password: '',
})

const loading = ref(false)

function onLogIn() {
    loading.value = true

    user.logIn(credentials)
        .then(() => {
            toast('Úspěšné přihlášení', 'success')
            router.push({ name: Route.home })
        })
        .catch(() => {
            toast('Přihlášení nebylo úspěšné', 'danger')
            return
        })
        .finally(() => {
            loading.value = false
        })
}
</script>

<style>
.max-h {
    max-height: 200px;
}
</style>
